/* 
 * Template for print_ routines.
 *
 *
 *
 */
#include "trace.h"
#include "sysname.h"
#include <sys/socket.h>

extern FILE *outfp;
extern int max_string;


/* socket(int addr_family, int type, int protocol); */
int printargs_socket(long sysCallno, long *sysArgs, int sysNumargs, char *sysFormat)
{
    int addr_family=sysArgs[0], type=sysArgs[1], protocol=sysArgs[2];
    char *famname, *typname, *protname;

    switch(addr_family) {
	case AF_UNIX:     famname="AF_UNIX"; break;
	case AF_INET:     famname="AF_INET"; break;
	case AF_IMPLINK:  famname="AF_IMPLINK"; break;
	case AF_PUP:      famname="AF_PUP"; break;
	case AF_CHAOS:    famname="AF_CHAOS"; break;
	case AF_NS:       famname="AF_NS"; break;
	case AF_ISO:      famname="AF_ISO"; break;
	case AF_ECMA:     famname="AF_ECMA"; break;
	case AF_DATAKIT:  famname="AF_DATAKIT"; break;
	case AF_CCITT:    famname="AF_CCITT"; break;
	case AF_SNA:      famname="AF_SNA"; break;
	case AF_DECnet:      famname="AF_DEC"; break;
	case AF_DLI:      famname="AF_DLI"; break;
	case AF_LAT:      famname="AF_LAT"; break;
	case AF_HYLINK:   famname="AF_HYLINK"; break;
	case AF_APPLETALK: famname="AF_APPLETALK"; break;
	case AF_ROUTE:    famname="AF_ROUTE"; break;
	case AF_LINK:     famname="AF_LINK"; break;
	case pseudo_AF_XTP: famname="pseudo_AF_XTP"; break;
	case AF_NETMAN:   famname="AF_NETMAN"; break;
	case AF_X25:      famname="AF_X25"; break;
	case AF_CTF:      famname="AF_CTF"; break;
	case AF_WAN:      famname="AF_WAN"; break;
	default:          famname="AF_???"; break;
    }
    switch(type) {
	case SOCK_STREAM: typname="STREAM"; break;
	case SOCK_DGRAM: typname="DGRAM"; break;
	case SOCK_RAW:   typname="RAW"; break;
	default: typname="SOCK_???"; break;
    }
    switch(protocol) {
	case PF_UNSPEC: protname="PF_UNSPEC"; break;       
	case PF_UNIX: protname="PF_UNIX"; break;        
	case PF_INET: protname="PF_INET"; break;       
	case PF_IMPLINK: protname="PF_IMPLINK"; break;   
	case PF_PUP: protname="PF_PUP"; break;      
	case PF_CHAOS: protname="PF_CHAOS"; break;   
	case PF_NS: protname="PF_NS"; break;          
	case PF_ISO: protname="PF_ISO"; break;         
	case PF_ECMA: protname="PF_ECMA"; break;      
	case PF_DATAKIT: protname="PF_DATAKIT"; break;  
	case PF_CCITT: protname="PF_CCITT"; break;   
	case PF_SNA: protname="PF_SNA"; break;    
	case PF_DECnet: protname="PF_DECnet"; break; 
	case PF_DLI: protname="PF_DLI"; break;   
	case PF_LAT: protname="PF_LAT"; break;  
	case PF_HYLINK: protname="PF_HYLINK"; break; 
	case PF_APPLETALK: protname="PF_APPLETALK"; break;  
	case PF_ROUTE: protname="PF_ROUTE"; break;     
	case PF_LINK: protname="PF_LINK"; break;     
	case PF_XTP: protname="PF_XTP"; break;     
	case PF_NETMAN: protname="PF_NETMAN"; break; 
	case PF_X25: protname="PF_X25"; break;   
	case PF_CTF: protname="PF_CTF"; break;  
	case PF_WAN: protname="PF_WAN"; break; 
	default: protname="PF_???"; break;
    }
    fprintf(outfp,"socket (%s,%s,%s) = ",famname,typname,protname);

    return(1);
}

int printret_socket(long sysCallno, long sysReturn, int sysErrno)
{
    if(sysReturn!=-1)
	fprintf(outfp,"%d\n",(int)sysReturn);
    else
	fprintf(outfp,"-1 (%s)\n",sys_errlist[sysErrno]);
    return(1);
} 
